// hybrid 项目中，ydk.js(A) 和 YoudaoWebViewJavascriptBridge.js(B) 会按 AB 的先后顺序压缩到
// 一个 js 文件中，由于 A 严重依赖于 B，且强制先后顺序，为避免开发人员忘了引入 B 而导致不可用
// 情况的发生，A 需要知道 B 的存在，这里利用 js 函数提前的 hack，在此声明一个桩函数供 A 提前
// 预判是否需要格外载入 B。
function __hasYoudaoWebViewJavascriptBridgeInThisFile () {};

/******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};

/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {

/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId])
/******/ 			return installedModules[moduleId].exports;

/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			exports: {},
/******/ 			id: moduleId,
/******/ 			loaded: false
/******/ 		};

/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);

/******/ 		// Flag the module as loaded
/******/ 		module.loaded = true;

/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}


/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;

/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;

/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";

/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(0);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/*!*******************************!*\
  !*** multi native.mobile.jsb ***!
  \*******************************/
/***/ function(module, exports, __webpack_require__) {

	module.exports = __webpack_require__(/*! /Users/chengmu/code/gitlab/dict_js_sdk/javascript/src/entrys/native.mobile.jsb/main.js */1);


/***/ },
/* 1 */
/*!**********************************************!*\
  !*** ./src/entrys/native.mobile.jsb/main.js ***!
  \**********************************************/
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	__webpack_require__(/*! ./interceptors.js */ 2);

	var _bridge = __webpack_require__(/*! ./bridge.js */ 4);

	var interfaces = _interopRequireWildcard(_bridge);

	function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj["default"] = obj; return newObj; } }

	// hybrid 项目中，ydk.js(A) 和 YoudaoWebViewJavascriptBridge.js(B) 会按 AB 的先后顺序压缩到
	// 一个 js 文件中，由于 A 严重依赖于 B，且强制先后顺序，为避免开发人员忘了引入 B 而导致不可用
	// 情况的发生，A 需要知道 B 的存在，这里利用 js 函数提前的 hack，在此声明一个桩函数供 A 提前
	// 预判是否需要格外载入 B。
	// 见hock.js
	//
	// 流程图参考 http://www.processon.com/view/link/54d088f0e4b016de1881a044
	// 流程图的访问密码为：youdao
	;(function (global, undefined) {

	  if (global.YoudaoWebViewJavascriptBridge) {
	    return;
	  }

	  // 这里的判断看起来没太有必要，仅在项目和 YDK 同处于开发阶段时，为了测试的便利会把
	  // ydk.js、YoudaoWebViewJavascriptBridge.js 和 WebJavascriptBridge.js 同时打包在一起
	  // 这种情况下，需要通过 UA 来判定是否该初始化哪个 bridge
	  // console.log('web view js bridge 1', ydk)
	  if (global.ydk && !ydk.isSupportNativeJsBridge) return;
	  // console.log('web view js bridge 2')


	  // WebViewJavascriptBridge 更名为 YoudaoWebViewJavascriptBridge，但依然兼容之前的
	  // 名称。因为 WebViewJavascriptBridge 这个名称和第三方页面上的变量冲突可能性较大
	  global.WebViewJavascriptBridge = global.YoudaoWebViewJavascriptBridge = interfaces;

	  var doc = document;
	  var readyEvent = doc.createEvent('Events');
	  readyEvent.initEvent('YoudaoWebViewJavascriptBridgeReady');
	  readyEvent.bridge = YoudaoWebViewJavascriptBridge;
	  doc.dispatchEvent(readyEvent);

	  // -----------------------------------------------------------------------------
	})(window);

/***/ },
/* 2 */
/*!******************************************************!*\
  !*** ./src/entrys/native.mobile.jsb/interceptors.js ***!
  \******************************************************/
/***/ function(module, exports, __webpack_require__) {

	"use strict";

	var _response = __webpack_require__(/*! entrys/web.jsb/response.js */ 3);

	var response = _interopRequireWildcard(_response);

	function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj["default"] = obj; return newObj; } }

	/**
	 * 由于当使用http协议访问时候，无法访问file协议的资源，因此需要拦截
	 */
	if (location.protocol != "file:") {
	  ydk.downloadImage = function (params) {
	    var img = new Image();
	    img.onload = function () {
	      this.onerror = this.onload = null;
	      var res = {
	        code: 1000,
	        errMsg: "",
	        localId: params.serverId,
	        rate: 100,
	        width: this.width,
	        height: this.height
	      };
	      params.success && params.success(res);
	      params.complete && params.complete(res);
	    };
	    img.onerror = function () {
	      this.onerror = this.onload = null;
	      params.fail && params.fail(res);
	      params.complete && params.complete(res);
	    };
	    img.src = params.serverId;
	    img = null;
	  };
	}

/***/ },
/* 3 */
/*!****************************************!*\
  !*** ./src/entrys/web.jsb/response.js ***!
  \****************************************/
/***/ function(module, exports) {

	"use strict";

	exports.__esModule = true;
	/**
	 * Response 状态的快捷对象
	 */

	var _response_1000 = exports._response_1000 = {
	  code: 1000,
	  errMsg: ""
	};

	var _response_1002 = exports._response_1002 = {
	  code: 1002,
	  errMsg: ""
	};

/***/ },
/* 4 */
/*!************************************************!*\
  !*** ./src/entrys/native.mobile.jsb/bridge.js ***!
  \************************************************/
/***/ function(module, exports, __webpack_require__) {

	/* WEBPACK VAR INJECTION */(function(global) {'use strict';

	exports.__esModule = true;
	exports._androidDispatchRequest = exports._deskDispatchRequest = undefined;
	exports.init = init;
	exports.send = send;
	exports.registerHandler = registerHandler;
	exports.callHandler = callHandler;
	exports._fetchQueue = _fetchQueue;
	exports._dispatchMessageFromNative = _dispatchMessageFromNative;
	exports._handleMessageFromNative = _handleMessageFromNative;
	exports._simulateInvoke = _simulateInvoke;

	var _iframer = __webpack_require__(/*! ./iframer.js */ 5);

	var iframer = _interopRequireWildcard(_iframer);

	function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj["default"] = obj; return newObj; } }

	var messagingIframe; /**
	                      * ydk使用限制，只能最顶层使用ydk
	                      * 当包含iframe时候，iframe的页面没办法获取ydk的回调:_androidDispatchRequest
	                      */

	var sendMessageQueue = [];
	var receiveMessageQueue = [];
	var messageHandlers = {};

	var CUSTOM_PROTOCOL_SCHEME = 'wvjbscheme';
	var QUEUE_HAS_MESSAGE = '__WVJB_QUEUE_MESSAGE__';

	var responseCallbacks = {};
	var uniqueId = Math.ceil(Math.random() * 10000);

	var _messageHandler;

	// android 暴露的全局方法名
	// window词典7.0+  暴露的全局方法名
	var awvjb = global['_YoudaoWebViewJavascriptBridge_'] || global['_WebViewJavascriptBridge_'];

	function _handleRequest(msgString) {
	  var msgs = JSON.parse(msgString);
	  for (var i = 0, l = msgs.length; i < l; i++) {
	    _handleMessageFromNative(msgs[i]);
	  }
	}

	function _nativeDispatchRequest() {
	  var msgString = awvjb._fetchQueue();
	  iframer.post(msgString);
	  _handleRequest(msgString);
	}

	var _deskDispatchRequest = exports._deskDispatchRequest = _nativeDispatchRequest;
	var _androidDispatchRequest = exports._androidDispatchRequest = _nativeDispatchRequest;

	function _createQueueReadyIframe(doc) {
	  messagingIframe = doc.createElement('iframe');
	  messagingIframe.style.display = 'none';
	  messagingIframe.src = CUSTOM_PROTOCOL_SCHEME + '://' + QUEUE_HAS_MESSAGE;
	  doc.documentElement.appendChild(messagingIframe);
	}

	function defaultMessageHandler(message, responseCallback) {
	  responseCallback && responseCallback({});
	}

	function init(messageHandler) {
	  if (_messageHandler) {
	    throw new Error('YoudaoWebViewJavascriptBridge.init called twice');
	  }
	  _messageHandler = messageHandler || defaultMessageHandler;
	  var receivedMessages = receiveMessageQueue;
	  receiveMessageQueue = null;
	  for (var i = 0; i < receivedMessages.length; i++) {
	    _dispatchMessageFromNative(receivedMessages[i]);
	  }

	  iframer.listen(function (msgString) {
	    _handleRequest(msgString);
	  });
	}

	function send(data, responseCallback) {
	  _doSend({ data: data }, responseCallback);
	}

	function registerHandler(handlerName, handler) {
	  messageHandlers[handlerName] = handler;
	}

	function callHandler(handlerName, data, responseCallback, undeleteAferCalled) {
	  _doSend({
	    handlerName: handlerName,
	    data: data
	  }, responseCallback, undeleteAferCalled);
	}

	function _doSend(message, responseCallback, undeleteAferCalled) {
	  if (responseCallback) {
	    var callbackId;
	    callbackId = (undeleteAferCalled ? 'u' : '') + 'cb_' + uniqueId++ + '_' + new Date().getTime();
	    responseCallbacks[callbackId] = responseCallback;
	    message['callbackId'] = callbackId;
	  }
	  sendMessageQueue.push(message);
	  if (awvjb) {
	    awvjb._flushMessageQueue(_fetchQueue());
	  } else {
	    messagingIframe.src = CUSTOM_PROTOCOL_SCHEME + '://' + QUEUE_HAS_MESSAGE;
	  }
	}

	function _fetchQueue() {
	  var messageQueueString = JSON.stringify(sendMessageQueue);
	  sendMessageQueue = [];
	  return messageQueueString;
	}

	function _dispatchMessageFromNative(messageJSON) {
	  setTimeout(function _timeoutDispatchMessageFromNative() {
	    // var message = JSON.parse(messageJSON)
	    var message = messageJSON;
	    var messageHandler;
	    var responseCallback;
	    if (message.responseId) {
	      responseCallback = responseCallbacks[message.responseId];
	      if (!responseCallback) {
	        return;
	      }
	      try {
	        message.data.data && (message.data.data = JSON.parse(message.data.data));
	      } catch (error) {}
	      responseCallback(message.data);
	      if (!/^u/.test(message.responseId)) {
	        delete responseCallbacks[message.responseId];
	      }
	    } else {
	      if (message.callbackId) {
	        var callbackResponseId = message.callbackId;
	        responseCallback = function responseCallback(responseData) {
	          _doSend({ responseId: callbackResponseId, data: responseData });
	        };
	      }

	      var handler = _messageHandler;
	      if (message.handlerName) {
	        handler = messageHandlers[message.handlerName];
	        // native 调用的前端方法不存在时
	        if (!handler && responseCallback) {
	          responseCallback({ code: 1004, errMsg: "api not found: " + message.handlerName });
	        }
	      }

	      try {
	        handler(message.data, responseCallback, message.handlerName);
	      } catch (exception) {
	        if (typeof console != 'undefined') {
	          console.log("YoudaoWebViewJavascriptBridge: WARNING: maybe api not found: " + message.handlerName);
	          console.log("YoudaoWebViewJavascriptBridge: WARNING: javascript handler threw.", message, exception);
	        }
	      }
	    }
	  });
	}

	function _handleMessageFromNative(messageJSON) {
	  messageJSON = isString(messageJSON) ? JSON.parse(messageJSON) : messageJSON;
	  if (receiveMessageQueue) {
	    receiveMessageQueue.push(messageJSON);
	  } else {

	    _dispatchMessageFromNative(messageJSON);
	  }
	}

	function isString(obj) {
	  return Object.prototype.toString.call(obj) === '[object String]';
	}

	// 模拟客户端发起的调用
	function _simulateInvoke(handlerName, data, callback) {

	  iframer.post('[' + JSON.stringify({
	    handlerName: handlerName,
	    data: data
	  }) + ']');

	  var handler = messageHandlers[handlerName];
	  if (!handler) {
	    return callback({ code: 1004, errMsg: "api not found: " + handlerName });
	  }
	  handler(data, function (res) {
	    callback(res);
	  }, handlerName);
	}

	var doc = document;
	var ua = navigator.userAgent.toLowerCase() || '';

	// !awvjb && _createQueueReadyIframe(doc)
	if (/iphone/i.test(ua) || /ipad/i.test(ua) || /ipod/i.test(ua)) {
	  _createQueueReadyIframe(doc);
	}
	/* WEBPACK VAR INJECTION */}.call(exports, (function() { return this; }())))

/***/ },
/* 5 */
/*!*************************************************!*\
  !*** ./src/entrys/native.mobile.jsb/iframer.js ***!
  \*************************************************/
/***/ function(module, exports) {

	'use strict';

	exports.__esModule = true;
	exports.post = post;
	exports.invoke = invoke;
	exports.listen = listen;
	/**
	 * 向iframe传递ydk消息
	 */
	function post(msgString) {
	  try {
	    var frames = window.frames;
	    var len = frames.length;
	    for (var i = 0; i < len; i++) {
	      frames[i].postMessage({
	        ydk: msgString
	      }, '*');
	    };
	  } catch (e) {
	    console.log(e);
	  }
	}

	/**
	 * 发送消息给顶层窗口
	 */
	function invoke(handlerName, data) {
	  var msg = {
	    code: 1000,
	    data: data
	  };
	  if (top == window) {
	    //由于listen会过滤同源消息，所以采用ydk接口通知
	    ydk._simulateNative(handlerName, msg, function () {});
	  } else {
	    top.postMessage({
	      ydk: '[' + JSON.stringify({
	        handlerName: handlerName,
	        data: msg
	      }) + ']'
	    }, '*');
	  }
	}

	function listen(callback) {
	  window.addEventListener('message', function (e) {
	    //跳过当前对象发送的事件
	    if (e.source == window || !e.data || !e.data.ydk) return;
	    post(e.data.ydk);
	    callback(e.data.ydk);
	  });
	}

/***/ }
/******/ ]);